VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   735
      Left            =   840
      TabIndex        =   0
      Top             =   600
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New Illustrator.Application
Dim myDefaultLayers

Private Sub Command1_Click()
    myDefaultLayers = Array("Walls", "Dimensions", "Callouts")
    doMakeDocument
End Sub

Private Sub doMakeDocument()
    Dim myDocument, myWidth, myHeight, myCMYKColor, myLayerName, myNewLayer
    myWidth = 400#
    myHeight = 800#
    Set myDocument = myApp.Documents.Add(aiDocumentCMYKColor, myWidth, myHeight)
    
    myDocument.DefaultFilled = True
    Set myCMYKColor = New Illustrator.CMYKColor
    myCMYKColor.Cyan = 0
    myCMYKColor.Magenta = 50
    myCMYKColor.Yellow = 0
    myCMYKColor.Black = 0
    myDocument.DefaultFillColor.CMYK = myCMYKColor
    myDocument.DefaultFillOverprint = False
   
    myDocument.DefaultStroked = True
    myCMYKColor.Cyan = 100
    myCMYKColor.Magenta = 0
    myCMYKColor.Yellow = 0
    myCMYKColor.Black = 0
    myDocument.DefaultStrokeColor.CMYK = myCMYKColor
   
    myDocument.DefaultStrokeWidth = 2#
    myDocument.DefaultStrokeCap = aiRoundEndCap
    myDocument.DefaultStrokeJoin = aiRoundEndJoin
    myDocument.DefaultStrokeDashOffset = 0#
    myDocument.DefaultStrokeDashes = Array(2#, 0.5, 2#, 0.5)
    myDocument.DefaultStrokeOverprint = False
   
    If UBound(myDefaultLayers) > -1 Then
        For Each myLayerName In myDefaultLayers
            Set myNewLayer = myDocument.Layers.Add()
            myNewLayer.Name = myLayerName
            myNewLayer.MoveToEnd (myDocument)
        Next
        myDocument.Layers.Remove (myDocument.Layers(1))
    End If
    
    myDocument.Views(1).Zoom = 0.75
    myDocument.Views(1).ScreenMode = aiMultiWindow
End Sub




