VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.DirListBox Dir1 
      Height          =   2565
      Left            =   240
      TabIndex        =   2
      Top             =   600
      Width           =   4335
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   1680
      TabIndex        =   1
      Top             =   120
      Width           =   2895
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp, myFolder, myFileSysObject

Private Sub Drive1_Change()
    Dir1.Path = Drive1.Drive & ":\"
End Sub

Private Sub Command1_Click()
    Dim myNum, myTextFile, myFont, myFontName, myTextArtItem, myFound, myChar
    Dim myNewFile, mySaveOptions
    If Dir1.Path <> "" Then
        myFolder = Dir1.Path
        Set myApp = New Illustrator.Application
        If myApp.Documents.Count > 0 Then
            Set myFileSysObject = New FileSystemObject
            
            If myApp.Documents(1).RasterItems.Count > 0 Then
                For myNum = 1 To myApp.Documents(1).RasterItems.Count
                    If myApp.Documents(1).RasterItems(myNum).Embedded = False Then
                        doCopyFile (myApp.Documents(1).RasterItems(myNum).File)
                    End If
                Next
            End If
            
            If myApp.Documents(1).PlacedItems.Count > 0 Then
                For myNum = 1 To myApp.Documents(1).PlacedItems.Count
                    doCopyFile (myApp.Documents(1).PlacedItems(myNum).File)
                Next
            End If
                        
            Set myTextFile = myFileSysObject.OpenTextFile(myFolder & "\Font Report.txt", ForWriting, True)
            myTextFile.Write ("Fonts used:" & vbCrLf)
            For Each myFont In myApp.TextFaces
                myFontName = myFont.Name
                For Each myTextArtItem In myApp.Documents(1).TextArtItems
                    myFound = False
                    For Each myChar In myTextArtItem.TextRange().Paragraphs
                        'use Characters for exhaustive font search
                        If myChar.Font = myFontName Then
                            myFound = True
                            Exit For
                        End If
                    Next
                    If myFound = True Then
                        myTextFile.Write (myFontName & vbCrLf)
                        Exit For
                    End If
                Next
            Next
            myTextFile.Close

            myNewFile = myFolder & "\" & myApp.Documents(1).Name
            Set mySaveOptions = New Illustrator.IllustratorSaveOptions
            myApp.Documents(1).SaveAs myNewFile, mySaveOptions
            MsgBox ("Collect for output complete.")
        End If
    End If
End Sub

Private Sub doCopyFile(myFilePath)
    Dim myFileName
    myFileName = myFileSysObject.GetFileName(myFilePath)
    myFileSysObject.CopyFile myFilePath, myFolder & "\" & myFileName, True
End Sub
