VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   615
      Left            =   1560
      TabIndex        =   0
      Top             =   960
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New Illustrator.Application

Private Sub Command1_Click()
    Dim myXscale, myYscale, myNum, myItemName, myTagExists, myBounds, myTag
    If myApp.Documents.Count > 0 Then
        myXscale = myApp.Documents(1).TextArtItems("Xscale").Contents
        myYscale = myApp.Documents(1).TextArtItems("Yscale").Contents
        myXscale = CSng(Left(myXscale, Len(myXscale) - 1))
        myYscale = CSng(Left(myXscale, Len(myYscale) - 1))
        If myXscale < 1# Then myXscale = 1#
        If myXscale > 200# Then myXscale = 200#
        If myYscale < 1# Then myYscale = 1#
        If myYscale > 200# Then myYscale = 200#
        For myNum = 1 To myApp.Documents(1).PageItems.Count
            myItemName = myApp.Documents(1).PageItems(myNum).Name
            If myItemName <> "Xscale" And myItemName <> "Yscale" Then
                myTagExists = False
                For Each myTag In myApp.Documents(1).PageItems(myNum).Tags
                    If myTag.Name = "OriginalBounds" Then
                        myTagExists = True
                        Exit For
                    End If
                Next
                If myTagExists Then
                    'Retrieve original bounds from tag.
                    myBounds = getBounds(myNum)
                    myApp.Documents(1).PageItems(myNum).Position = Array(myBounds(0), myBounds(1))
                    myApp.Documents(1).PageItems(myNum).Width = myBounds(2)
                    myApp.Documents(1).PageItems(myNum).Height = myBounds(3)
                Else
                    'Store current bounds in a tag.
                    setBounds myNum
                End If
                'Scale based on new scale value.
                myApp.Documents(1).PageItems(myNum).Resize myXscale, myYscale, , , , , , aiTransformCenter
            End If
        Next
    End If
End Sub

Private Sub setBounds(myNum)
    Dim myPosition, myWidth, myHeight, myBoundsString, myTag
    myPosition = myApp.Documents(1).PageItems(myNum).Position
    myWidth = myApp.Documents(1).PageItems(myNum).Width
    myHeight = myApp.Documents(1).PageItems(myNum).Height
    myBoundsString = myPosition(0) & "," & myPosition(1) & ","
    myBoundsString = myBoundsString & myWidth & "," & myHeight
    Set myTag = myApp.Documents(1).PageItems(myNum).Tags.Add
    myTag.Name = "OriginalBounds"
    myTag.Value = myBoundsString
End Sub

Private Function getBounds(myNum)
    Dim myValue, myList
    myValue = myApp.Documents(1).PageItems(myNum).Tag("OriginalBounds")
    myList = Split(myValue, ",")
    getBounds = myList
End Function
