VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3600
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3600
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.DirListBox Dir1 
      Height          =   1440
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   4455
   End
   Begin VB.FileListBox File1 
      Height          =   870
      Left            =   120
      TabIndex        =   2
      Top             =   2640
      Width           =   4455
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   1440
      TabIndex        =   1
      Top             =   600
      Width           =   3135
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Select Folder"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Select folder to save imposition sheet files"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   4455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New illustrator.Application
Dim myFolder, myFrontPageLeft, myFrontPageRight, myBackPageLeft, myBackPageRight
Dim myFrontPagePairs, myBackPagePairs, myNum

Private Sub Drive1_Change()
    If Drive1.Drive <> "" Then
        Dir1.Path = Left(Drive1.Drive, 1) & ":\"
        File1.Path = Dir1.Path
    End If
End Sub

Private Sub Dir1_Change()
    If File1.Path <> "" Then
        File1.Path = Dir1.Path
    End If
End Sub

Private Sub Command1_Click()
    Dim myPageCount, myValidPageCount, myPageWidth, myPageHeight, myPageColorSpace
    Dim mySheetHeight, mySheetWidth, myPath, myPathPoint
    Dim myLeftFilePath, myRightFilePath, myFrontDoc, myBackDoc
    Dim myPlacedArt, mySheetFilePath
    'Set up imposition page layout page ordering for the following
    '(2 pages per side per sheet): 8 pages, 16 pages, 24 pages, or 32 pages long.
    If TypeName(myNum) = "Empty" Then myNum = 0
    Select Case Command1.Caption
        Case "Select Folder"
            If Dir1.Path <> "" Then
                myFolder = Dir1.Path
                myPageCount = InputBox("Enter page count(8,16,24,32):", , "8")
                Select Case myPageCount
                    Case "8"
                        myFrontPagePairs = Array(Array(8, 1), Array(6, 3))
                        myBackPagePairs = Array(Array(2, 7), Array(4, 5))
                        myValidPageCount = True
                    Case "16"
                        myFrontPagePairs = Array(Array(16, 1), Array(14, 3), Array(12, 5), Array(10, 7))
                        myBackPagePairs = Array(Array(2, 15), Array(4, 13), Array(6, 11), Array(8, 9))
                        myValidPageCount = True
                    Case "24"
                        myFrontPagePairs = Array(Array(24, 1), Array(22, 3), Array(20, 5), Array(18, 7), Array(16, 8), Array(14, 1))
                        myBackPagePairs = Array(Array(2, 23), Array(4, 21), Array(6, 19), Array(8, 17), Array(10, 15), Array(12, 13))
                        myValidPageCount = True
                    Case "32"
                        myFrontPagePairs = Array(Array(32, 1), Array(30, 3), Array(28, 5), Array(26, 7), Array(24, 9), Array(22, 11), Array(20, 13), Array(18, 15))
                        myBackPagePairs = Array(Array(2, 31), Array(4, 29), Array(6, 27), Array(8, 25), Array(10, 23), Array(12, 21), Array(14, 19), Array(16, 17))
                        myValidPageCount = True
                    Case Else
                        myValidPageCount = False
                End Select
                'Initialize lists of page-pairs for front and back of each sheet of imposition layout.
                If myValidPageCount = True Then
                    myNum = 0
                    Command1.Caption = "Step 1"
                    Label1.Caption = "Select page # " & myFrontPagePairs(myNum)(0)
                End If
            End If
        Case "Step 1"
            If File1.FileName <> "" Then
                myFrontPageLeft = File1.Path & "\" & File1.FileName
                Command1.Caption = "Step 2"
                Label1.Caption = "Select page # " & myFrontPagePairs(myNum)(1)
            End If
        Case "Step 2"
            If File1.FileName <> "" Then
                myFrontPageRight = File1.Path & "\" & File1.FileName
                Command1.Caption = "Step 3"
                Label1.Caption = "Select page # " & myBackPagePairs(myNum)(0)
            End If
        Case "Step 3"
            If File1.FileName <> "" Then
                myBackPageLeft = File1.Path & "\" & File1.FileName
                Command1.Caption = "Step 4"
                Label1.Caption = "Select page # " & myBackPagePairs(myNum)(1)
            End If
        Case "Step 4"
            If File1.FileName <> "" Then
                myBackPageRight = File1.Path & "\" & File1.FileName
                Set myApp = New illustrator.Application
                
                'Ready to create impositions for current sheet.
                myApp.Open (myFrontPageLeft)
                'Open left-hand page for front of sheet.
                myPageWidth = myApp.Documents(1).Width
                myPageHeight = myApp.Documents(1).Height
                myPageColorSpace = myApp.Documents(1).DocumentColorSpace
                mySheetHeight = myPageHeight
                mySheetWidth = myPageWidth * 2
                'Get document size to calculate the imposition sheet size, which is same height and twice the width.
                Set myPath = myApp.Documents(1).PathItems.Add
                myPath.Stroked = True
                myPath.Filled = False
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, 0)
                myPathPoint.RightDirection = Array(0, 0)
                myPathPoint.Anchor = Array(0, 0)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(myPageWidth, 0)
                myPathPoint.RightDirection = Array(myPageWidth, 0)
                myPathPoint.Anchor = Array(myPageWidth, 0)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(myPageWidth, myPageHeight)
                myPathPoint.RightDirection = Array(myPageWidth, myPageHeight)
                myPathPoint.Anchor = Array(myPageWidth, myPageHeight)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, myPageHeight)
                myPathPoint.RightDirection = Array(0, myPageHeight)
                myPathPoint.Anchor = Array(0, myPageHeight)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, 0)
                myPathPoint.RightDirection = Array(0, 0)
                myPathPoint.Anchor = Array(0, 0)
                'Create an invisible rectangular path to bound the sheet size.
                myLeftFilePath = exportDocument("eps", "", "", False)
                'Export as EPS to place into imposition sheet, file will end up being closed.
                myApp.Open (myFrontPageRight)
                'Open right-hand page for front of sheet.
                Set myPath = myApp.Documents(1).PathItems.Add
                myPath.Stroked = True
                myPath.Filled = False
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, 0)
                myPathPoint.RightDirection = Array(0, 0)
                myPathPoint.Anchor = Array(0, 0)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(myPageWidth, 0)
                myPathPoint.RightDirection = Array(myPageWidth, 0)
                myPathPoint.Anchor = Array(myPageWidth, 0)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(myPageWidth, myPageHeight)
                myPathPoint.RightDirection = Array(myPageWidth, myPageHeight)
                myPathPoint.Anchor = Array(myPageWidth, myPageHeight)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, myPageHeight)
                myPathPoint.RightDirection = Array(0, myPageHeight)
                myPathPoint.Anchor = Array(0, myPageHeight)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, 0)
                myPathPoint.RightDirection = Array(0, 0)
                myPathPoint.Anchor = Array(0, 0)
                'Create an invisible rectangular path to bound the sheet size.
                myRightFilePath = exportDocument("eps", "", "", False)
                'Export as EPS to place into imposition sheet, file will end up being closed.

                Set myFrontDoc = myApp.Documents.Add(myPageColorSpace, mySheetWidth, mySheetHeight)
                'Now we can  make front sheet file.
                Set myPlacedArt = myApp.Documents(1).PlacedItems.Add
                myPlacedArt.MoveToBeginning (myFrontDoc)
                myPlacedArt.File = myLeftFilePath
                myPlacedArt.Position = Array(0, myPageHeight)
                'Place left page eps.
                Set myPlacedArt = myApp.Documents(1).PlacedItems.Add
                myPlacedArt.MoveToBeginning (myFrontDoc)
                myPlacedArt.File = myRightFilePath
                myPlacedArt.Position = Array(myPageWidth, myPageHeight)
                'Place right page eps.
                mySheetFilePath = exportDocument("pdf", (myNum + 1) & "-front", myFolder, False)
                'Save front sheet and close it.

                myApp.Open (myBackPageLeft)
                'Open left-hand page for back of sheet.
                Set myPath = myApp.Documents(1).PathItems.Add
                myPath.Stroked = True
                myPath.Filled = False
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, 0)
                myPathPoint.RightDirection = Array(0, 0)
                myPathPoint.Anchor = Array(0, 0)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(myPageWidth, 0)
                myPathPoint.RightDirection = Array(myPageWidth, 0)
                myPathPoint.Anchor = Array(myPageWidth, 0)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(myPageWidth, myPageHeight)
                myPathPoint.RightDirection = Array(myPageWidth, myPageHeight)
                myPathPoint.Anchor = Array(myPageWidth, myPageHeight)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, myPageHeight)
                myPathPoint.RightDirection = Array(0, myPageHeight)
                myPathPoint.Anchor = Array(0, myPageHeight)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, 0)
                myPathPoint.RightDirection = Array(0, 0)
                myPathPoint.Anchor = Array(0, 0)
                'Create an invisible rectangular path to bound the sheet size.
                myLeftFilePath = exportDocument("eps", "", "", False)
                'Export as EPS to place into imposition sheet, file will end up being closed.
                myApp.Open (myBackPageRight)
                'Open right-hand page for front of sheet.
                Set myPath = myApp.Documents(1).PathItems.Add
                myPath.Stroked = True
                myPath.Filled = False
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, 0)
                myPathPoint.RightDirection = Array(0, 0)
                myPathPoint.Anchor = Array(0, 0)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(myPageWidth, 0)
                myPathPoint.RightDirection = Array(myPageWidth, 0)
                myPathPoint.Anchor = Array(myPageWidth, 0)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(myPageWidth, myPageHeight)
                myPathPoint.RightDirection = Array(myPageWidth, myPageHeight)
                myPathPoint.Anchor = Array(myPageWidth, myPageHeight)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, myPageHeight)
                myPathPoint.RightDirection = Array(0, myPageHeight)
                myPathPoint.Anchor = Array(0, myPageHeight)
                Set myPathPoint = myPath.PathPoints.Add
                myPathPoint.PointType = aiCorner
                myPathPoint.LeftDirection = Array(0, 0)
                myPathPoint.RightDirection = Array(0, 0)
                myPathPoint.Anchor = Array(0, 0)
                'Create an invisible rectangular path to bound the sheet size.
                myRightFilePath = exportDocument("eps", "", "", False)
                'Export as EPS to place into imposition sheet, file will end up being closed.

                Set myBackDoc = myApp.Documents.Add(myPageColorSpace, mySheetWidth, mySheetHeight)
                'Now we can  make back sheet file.
                Set myPlacedArt = myApp.Documents(1).PlacedItems.Add
                myPlacedArt.MoveToBeginning (myBackDoc)
                myPlacedArt.File = myLeftFilePath
                myPlacedArt.Position = Array(0, myPageHeight)
                'Place left page eps.
                Set myPlacedArt = myApp.Documents(1).PlacedItems.Add
                myPlacedArt.MoveToBeginning (myBackDoc)
                myPlacedArt.File = myRightFilePath
                myPlacedArt.Position = Array(myPageWidth, myPageHeight)
                'Place right page eps.
                mySheetFilePath = exportDocument("pdf", (myNum + 1) & "-back", myFolder, False)
                'Save back sheet and close it.
                
                'Prompt user for 4 files that comprise front page pair and back page pair for an imposition sheet.
                If myNum <= UBound(myFrontPagePairs) Then
                    myNum = myNum + 1
                    Command1.Caption = "Step 1"
                    Label1.Caption = "Select page # " & myFrontPagePairs(myNum)(0)
                    'Gather the page pairs for the front and back of the current sheet.
                Else
                    Command1.Caption = "Select Folder"
                    Label1.Caption = "Select folder to save imposition sheet files"
                    'All done.
                End If
            End If
    End Select
    
End Sub

'4.06
Private Function exportDocument(myFormat, myNameExtra, mySaveFolder, myRestoreFlag)
    Dim myOriginalFile, myNewPath, myCharNum, myExportOptions, myColor
    myOriginalFile = myApp.Documents(1).FullName
    If mySaveFolder <> "" Then
        myNewPath = mySaveFolder & "\"
        If Left(myOriginalFile, 1) <> "\" Then myNewPath = myNewPath & myApp.Documents(1).Name
    Else
        myNewPath = myOriginalFile
    End If
    If InStrRev(myOriginalFile, ".") > Len(myOriginalFile) - 5 Then
        myNewPath = Mid(myOriginalFile, 1, InStrRev(myOriginalFile, ".") - 1)
    End If
    myNewPath = myNewPath & myNameExtra
    Select Case myFormat
        Case "eps"
            myNewPath = myNewPath & ".eps"
            Set myExportOptions = New illustrator.EPSSaveOptions
            myExportOptions.CMYKPostScript = True
            myExportOptions.Compatibility = aiIllustrator10
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedLinkedFiles = True
            myExportOptions.IncludeDocumentThumbnails = True
            myExportOptions.PostScript = aiLevel2
            myExportOptions.Preview = aiColorTIFF
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
        Case "flash"
            myNewPath = myNewPath & ".swf"
            Set myExportOptions = New illustrator.ExportOptionsFlash
            myExportOptions.ArtBoardClipping = True
            myExportOptions.CurveQuality = 9
            myExportOptions.ExportStyle = aiLayersAsFrames
            myExportOptions.FrameRate = 15#
            myExportOptions.GenerateHTML = False
            myExportOptions.ImageFormat = aiLossy
            myExportOptions.JPEGMethod = aiJPEGOptimized
            myExportOptions.JPEGQuality = 7
            myExportOptions.Looping = False
            myExportOptions.ReadOnly = False
            myExportOptions.Replacing = aiSaveChanges
            myExportOptions.Resolution = 72#
            myApp.Documents(1).Export myNewPath, aiFlash, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
            
        Case "gif"
            myNewPath = myNewPath & ".gif"
            Set myExportOptions = New illustrator.ExportOptionsGIF
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.InfoLossPercent = 0
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New illustrator.RGBColor
            myColor.Red = 0#
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiGIF, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "jpeg"
            myNewPath = myNewPath & ".jpg"
            Set myExportOptions = New illustrator.ExportOptionsJPEG
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.BlurAmount = 0#
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.Optimization = True
            myExportOptions.QualitySetting = 70
            myExportOptions.SaveAsHTML = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiJPEG, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "pdf"
            myNewPath = myNewPath & ".pdf"
            Set myExportOptions = New illustrator.PDFSaveOptions
            myExportOptions.ColorCompression = aiJPEGHigh
            myExportOptions.ColorDownsampling = 300#
            myExportOptions.Compatibility = aiAcrobat4
            myExportOptions.CompressArt = True
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.FontSubsetThreshold = 0#
            myExportOptions.GenerateThumbnails = True
            myExportOptions.GrayscaleCompression = aiJPEGHigh
            myExportOptions.GrayscaleDownsampling = 200#
            myExportOptions.MonochromeCompression = aiCCIT3
            myExportOptions.MonochromeDownsampling = 600#
            myExportOptions.PreserveEditability = False
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
        
        Case "photoshop"
            myNewPath = myNewPath & ".psd"
            Set myExportOptions = New illustrator.ExportOptionsPhotoshop
            myExportOptions.AntiAliasing = True
            myExportOptions.CompoundShapes = True
            myExportOptions.EditableText = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.HiddenLayers = False
            myExportOptions.ImageColorSpace = aiImageCMYK
            myExportOptions.ImageMap = True
            myExportOptions.NestedLayers = True
            myExportOptions.Resolution = 144#
            myExportOptions.Slices = True
            myExportOptions.Warnings = False
            myExportOptions.WriteLayers = True
            myApp.Documents(1).Export myNewPath, aiPhotoshop, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "png24"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New illustrator.ExportOptionsPNG24
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiPNG24, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "png8"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New illustrator.ExportOptionsPNG8
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256#
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New illustrator.RGBColor
            myColor.Red = 0
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiPNG8, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
            
        Case "svg"
            myNewPath = myNewPath & ".svg"
            Set myExportOptions = New illustrator.ExportOptionsSVG
            myExportOptions.Compressed = False
            myExportOptions.CoordinatePrecision = 5
            myExportOptions.CSSProperties = aiStyleAttributes
            myExportOptions.DocumentEncoding = aiUTF8
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedRasterImages = True
            myExportOptions.FontSubsetting = aiAllGlyphs
            myExportOptions.IncludeFileInfo = True
            myExportOptions.IncludeVariablesAndDatasets = False
            myExportOptions.OptimizeForSVGViewer = True
            myExportOptions.PreserveEditability = False
            myExportOptions.Slices = True
            myApp.Documents(1).Export myNewPath, aiSVG, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
    End Select
    exportDocument = myNewPath
End Function
