VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   4335
   End
   Begin VB.DirListBox Dir1 
      Height          =   1890
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   4335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   2760
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New Illustrator.Application
Dim myFilesystem As New FileSystemObject
Dim myFiletypes
    
Private Sub Drive1_Change()
    Dir1.Path = Left(Drive1.Drive, 1) & ":\"
End Sub
'This subroutine is run whenever the user changes the drive selection in the DriveListBox. It updates the FolderListBox so it shows the new drive's contents.

Private Sub Command1_Click()
    myFiletypes = ".ai,.eps"
    If Dir1.Path = "" Then MsgBox ("Select a folder to process first")
    openFolder Dir1.Path
End Sub
'This subroutine is our main script. It is run when the user clicks on the button in the form.
'First we define the file extensions that should be processed by our script.
'If the button is pushed without any folder selected, an alert is shown to the user.


Private Sub openFolder(myStartingFolderpath)
    Dim myStartingFolder, myFiles, myFile, myItemExtension, myFolders, myFolder, myDoc
    Set myStartingFolder = myFilesystem.GetFolder(Dir1.Path)
    Set myFiles = myStartingFolder.Files
    For Each myFile In myFiles
        myItemExtension = Mid(myFile.Name, InStrRev(myFile.Name, "."))
        If InStr(myFiletypes, myItemExtension) > 0 Then
            Set myDoc = myApp.Open(myFile.Path)
            doProcessDocument myDoc.Name
        End If
    Next
    Set myFolders = myStartingFolder.SubFolders
    For Each myFolder In myFolders
        openFolder (myFolder)
    Next
End Sub
'The openFolder subroutine moves through each file in the folder passed to it, opened ones with valid extensions in Illustrator before calling the doProcessDocument subroutine.

Private Sub doProcessDocument(myDocumentName)
    myApp.Documents(myDocumentName).Close (aiDoNotSaveChanges)
End Sub
'doProcessDocument() is the main subroutine that the folder processor script calls to work with the current open document in Illustrator. This function simply closes the just-opened document, doing nothing to it.

