VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   735
      Left            =   840
      TabIndex        =   0
      Top             =   600
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New Illustrator.Application

Private Sub Command1_Click()
    Dim myDocumentCount
    myDocumentCount = myApp.Documents.Count
    If myDocumentCount > 0 Then
        doProcessObjects
    End If
End Sub

Private Sub doProcessObjects()
    Dim myObjectCount, myObjectNum, myObjectClass
    myObjectCount = myApp.Documents(1).PageItems.Count
    If myObjectCount > 0 Then
        For myObjectNum = 1 To myObjectCount
            myObjectClass = myApp.Documents(1).PageItems(myObjectNum).PageItemType
            Select Case myObjectClass
                Case aiCompoundPathItem
                    doProcessCompoundPath (myObjectNum)
                Case aiGraphItem
                    doProcessGraph (myObjectNum)
                Case aiGroupItem
                    doProcessGroup (myObjectNum)
                Case aiMeshItem
                    doProcessMesh (myObjectNum)
                Case aiPathItem
                    doProcessPath (myObjectNum)
                Case aiPlacedItem
                    doProcessPlaced (myObjectNum)
                Case aiPluginItem
                    doProcessPlugin (myObjectNum)
                Case aiRasterItem
                    doProcessRaster (myObjectNum)
                Case aiSymbolItem
                    doProcessSymbol (myObjectNum)
                Case aiTextArtItem
                    doProcessTextArt (myObjectNum)
            End Select
        Next
    End If
End Sub

Private Sub doProcessCompoundPath(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is a compound path")
End Sub

Private Sub doProcessGraph(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is a graph")
End Sub

Private Sub doProcessGroup(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is a group")
End Sub

Private Sub doProcessMesh(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is a mesh")
End Sub

Private Sub doProcessPath(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is a path")
End Sub

Private Sub doProcessPlaced(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is placed art")
End Sub

Private Sub doProcessPlugin(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is plugin art")
End Sub

Private Sub doProcessRaster(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is raster art")
End Sub

Private Sub doProcessSymbol(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is symbol art")
End Sub

Private Sub doProcessTextArt(myObjectNum)
    MsgBox ("page item " & myObjectNum & " is text art")
End Sub




