VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   735
      Left            =   840
      TabIndex        =   0
      Top             =   600
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New Illustrator.Application

Private Sub Command1_Click()
    Dim mySelectionType
    If myApp.Documents.Count > 0 Then
        mySelectionType = TypeName(myApp.Selection)
        If mySelectionType <> "Empty" Then
           doProcessSelection
        Else
            MsgBox ("No objects are selected")
        End If
    End If
End Sub

Private Sub doProcessSelection()
    Dim myObjectCount, mySelection, myObject, myObjectNum, myObjectClass
    myObjectCount = UBound(myApp.Selection) + 1
    If myObjectCount > 0 Then
        mySelection = myApp.Selection
        For myObjectNum = 1 To myObjectCount
            Set myObject = mySelection(myObjectNum - 1)
            myObjectClass = myObject.PageItem.PageItemType
            Select Case myObjectClass
                Case aiCompoundPathItem
                    doProcessCompoundPath (myObjectNum)
                Case aiGraphItem
                    doProcessGraph (myObjectNum)
                Case aiGroupItem
                    doProcessGroup (myObjectNum)
                Case aiMeshItem
                    doProcessMesh (myObjectNum)
                Case aiPathItem
                    doProcessPath (myObjectNum)
                Case aiPlacedItem
                    doProcessPlaced (myObjectNum)
                Case aiPluginItem
                    doProcessPlugin (myObjectNum)
                Case aiRasterItem
                    doProcessRaster (myObjectNum)
                Case aiSymbolItem
                    doProcessSymbol (myObjectNum)
                Case aiTextArtItem
                    doProcessTextArt (myObjectNum)
            End Select
        Next
    End If
End Sub

Private Sub doProcessCompoundPath(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is a compound path")
End Sub

Private Sub doProcessGraph(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is a graph")
End Sub

Private Sub doProcessGroup(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is a group")
End Sub

Private Sub doProcessMesh(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is a mesh")
End Sub

Private Sub doProcessPath(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is a path")
End Sub

Private Sub doProcessPlaced(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is placed art")
End Sub

Private Sub doProcessPlugin(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is plugin art")
End Sub

Private Sub doProcessRaster(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is raster art")
End Sub

Private Sub doProcessSymbol(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is symbol art")
End Sub

Private Sub doProcessTextArt(myObjectNum)
    MsgBox ("item " & myObjectNum & " of the selection is text art")
End Sub




