VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   735
      Left            =   840
      TabIndex        =   0
      Top             =   600
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New Illustrator.Application

Private Sub Command1_Click()
    Dim myFormat, myNameExtra, mySaveFolder, myRestoreFlag, myNewPath
    myFormat = "svg"
    myNameExtra = ""
    mySaveFolder = ""
    myRestoreFlag = True
    If myApp.Documents.Count > 0 Then
        myNewPath = exportDocument(myFormat, myNameExtra, mySaveFolder, myRestoreFlag)
    End If
End Sub

Private Function exportDocument(myFormat, myNameExtra, mySaveFolder, myRestoreFlag)
    Dim myOriginalFile, myNewPath, myCharNum, myExportOptions, myColor
    myOriginalFile = myApp.Documents(1).FullName
    If mySaveFolder <> "" Then
        myNewPath = mySaveFolder & "\"
        If Left(myOriginalFile, 1) <> "\" Then myNewPath = myNewPath & myApp.Documents(1).Name
    Else
        myNewPath = myOriginalFile
    End If
    If InStrRev(myOriginalFile, ".") > Len(myOriginalFile) - 5 Then
        myNewPath = Mid(myOriginalFile, 1, InStrRev(myOriginalFile, ".") - 1)
    End If
    myNewPath = myNewPath & myNameExtra
    Select Case myFormat
        Case "eps"
            myNewPath = myNewPath & ".eps"
            Set myExportOptions = New Illustrator.EPSSaveOptions
            myExportOptions.CMYKPostScript = True
            myExportOptions.Compatibility = aiIllustrator10
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedLinkedFiles = True
            myExportOptions.IncludeDocumentThumbnails = True
            myExportOptions.PostScript = aiLevel2
            myExportOptions.Preview = aiColorTIFF
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
        Case "flash"
            myNewPath = myNewPath & ".swf"
            Set myExportOptions = New Illustrator.ExportOptionsFlash
            myExportOptions.ArtBoardClipping = True
            myExportOptions.CurveQuality = 9
            myExportOptions.ExportStyle = aiLayersAsFrames
            myExportOptions.FrameRate = 15#
            myExportOptions.GenerateHTML = False
            myExportOptions.ImageFormat = aiLossy
            myExportOptions.JPEGMethod = aiJPEGOptimized
            myExportOptions.JPEGQuality = 7
            myExportOptions.Looping = False
            myExportOptions.ReadOnly = False
            myExportOptions.Replacing = aiSaveChanges
            myExportOptions.Resolution = 72#
            myApp.Documents(1).Export myNewPath, aiFlash, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
            
        Case "gif"
            myNewPath = myNewPath & ".gif"
            Set myExportOptions = New Illustrator.ExportOptionsGIF
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.InfoLossPercent = 0
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 0#
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiGIF, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "jpeg"
            myNewPath = myNewPath & ".jpg"
            Set myExportOptions = New Illustrator.ExportOptionsJPEG
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.BlurAmount = 0#
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.Optimization = True
            myExportOptions.QualitySetting = 70
            myExportOptions.SaveAsHTML = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiJPEG, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "pdf"
            myNewPath = myNewPath & ".pdf"
            Set myExportOptions = New Illustrator.PDFSaveOptions
            myExportOptions.ColorCompression = aiJPEGHigh
            myExportOptions.ColorDownsampling = 300#
            myExportOptions.Compatibility = aiAcrobat4
            myExportOptions.CompressArt = True
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.FontSubsetThreshold = 0#
            myExportOptions.GenerateThumbnails = True
            myExportOptions.GrayscaleCompression = aiJPEGHigh
            myExportOptions.GrayscaleDownsampling = 200#
            myExportOptions.MonochromeCompression = aiCCIT3
            myExportOptions.MonochromeDownsampling = 600#
            myExportOptions.PreserveEditability = False
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
        
        Case "photoshop"
            myNewPath = myNewPath & ".psd"
            Set myExportOptions = New Illustrator.ExportOptionsPhotoshop
            myExportOptions.AntiAliasing = True
            myExportOptions.CompoundShapes = True
            myExportOptions.EditableText = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.HiddenLayers = False
            myExportOptions.ImageColorSpace = aiImageCMYK
            myExportOptions.ImageMap = True
            myExportOptions.NestedLayers = True
            myExportOptions.Resolution = 144#
            myExportOptions.Slices = True
            myExportOptions.Warnings = False
            myExportOptions.WriteLayers = True
            myApp.Documents(1).Export myNewPath, aiPhotoshop, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "png24"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New Illustrator.ExportOptionsPNG24
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiPNG24, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "png8"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New Illustrator.ExportOptionsPNG8
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256#
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 0
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiPNG8, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
            
        Case "svg"
            myNewPath = myNewPath & ".svg"
            Set myExportOptions = New Illustrator.ExportOptionsSVG
            myExportOptions.Compressed = False
            myExportOptions.CoordinatePrecision = 5
            myExportOptions.CSSProperties = aiStyleAttributes
            myExportOptions.DocumentEncoding = aiUTF8
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedRasterImages = True
            myExportOptions.FontSubsetting = aiAllGlyphs
            myExportOptions.IncludeFileInfo = True
            myExportOptions.IncludeVariablesAndDatasets = False
            myExportOptions.OptimizeForSVGViewer = True
            myExportOptions.PreserveEditability = False
            myExportOptions.Slices = True
            myApp.Documents(1).Export myNewPath, aiSVG, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
    End Select
    exportDocument = myNewPath
End Function

