VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   1680
      TabIndex        =   2
      Text            =   "Combo1"
      Top             =   2760
      Width           =   2895
   End
   Begin VB.ListBox List1 
      Height          =   2595
      ItemData        =   "Form4-15.frx":0000
      Left            =   120
      List            =   "Form4-15.frx":0002
      TabIndex        =   1
      Top             =   120
      Width           =   4455
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   2760
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New illustrator.Application

Private Sub Form_Load()
    doRefreshControls
End Sub

Private Sub doRefreshControls()
    Dim mySelectionType, mySelection, myTagNames, myTag, myPageItem
    If myApp.Documents.Count > 0 Then
        mySelectionType = TypeName(myApp.Documents(1).Selection)
        If mySelectionType <> "Empty" Then
            mySelection = myApp.Documents(1).Selection
            Set myPageItem = mySelection(0)
            List1.Clear
            If myPageItem.Tags.Count > 0 Then
                ReDim myTagNames(myPageItem.Tags.Count + 2)
                For Each myTag In myPageItem.Tags
                    List1.AddItem myTag.Name
                Next
            End If
        End If
        List1.AddItem "<ADD ENTRY>"
        List1.AddItem "<SEARCH ALL TAGS>"
        Combo1.Clear
    End If
End Sub

Private Sub Command1_Click()
    Dim mySelectionType, mySelection, myTagName, myPageItem
    Dim myNewName, myNewValue, myNewTag, mySearchValue, myNum
    Dim myEntry, myTagValue
    If List1.ListIndex > -1 Then
        mySelectionType = TypeName(myApp.Documents(1).Selection)
        If mySelectionType <> "Empty" Then
            mySelection = myApp.Documents(1).Selection
            Set myPageItem = mySelection(0)
            myTagName = List1.List(List1.ListIndex)
            Select Case myTagName
                Case "<ADD ENTRY>"
                    myNewName = " "
                    Do While InStr(myNewName, " ") > 0
                        myNewName = InputBox("Name new entry", , "")
                        If InStr(myNewName, " ") > 0 Then
                            MsgBox ("Entry names cannot contain spaces.")
                        End If
                    Loop
                    If myNewName <> "" Then
                        myNewValue = InputBox("Set '" & myNewName & "' entry", , "")
                        Set myNewTag = myPageItem.Tags.Add
                        myNewTag.Name = myNewName
                        myNewTag.Value = myNewValue
                        doRefreshControls
                    End If
                Case "<SEARCH ALL TAGS>"
                    mySearchValue = InputBox("Search entries for what", "")
                    Combo1.Clear
                    For myNum = 1 To myApp.Documents(1).Tags.Count
                        If InStr(myApp.Documents(1).Tags(myNum).Value, mySearchValue) > 0 Then
                            myEntry = myNum & " " & myApp.Documents(1).Tags(myNum).Name
                            myEntry = myEntry & " (" & myApp.Documents(1).Tags(myNum).Value & ")"
                            Combo1.AddItem myEntry
                        End If
                    Next
                    If Combo1.ListCount = 0 Then
                        MsgBox ("No matches found for '" & mySearchValue & "'.")
                    End If
                Case Else
                    myTagValue = myPageItem.Tags(myTagName).Value
                    myNewValue = InputBox("Change '" & myTagName & "' entry", , myTagValue)
                    If myNewValue <> "" Then
                        myPageItem.Tags(myTagName).Value = myNewValue
                    Else
                        myPageItem.Tags.Remove (myPageItem.Tags(myTagName))
                    End If
            End Select
        End If
    End If
End Sub

Private Sub Combo1_Click()
    Dim myTagName, myTagNumber, myItemSelect
    If Combo1.ListIndex > -1 Then
        myApp.Documents(1).Selection = Empty
        myTagName = Combo1.List(Combo1.ListIndex)
        myTagNumber = Left(myTagName, InStr(myTagName, " ") - 1)
        myTagNumber = CInt(myTagNumber)
        Set myItemSelect = myApp.Documents(1).Tags(myTagNumber).Parent
        myItemSelect.Selected = True
    End If
End Sub
