VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   615
      Left            =   1560
      TabIndex        =   0
      Top             =   960
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim myApp As New Illustrator.Application

Private Sub Command1_Click()
    Dim myDBConnection, myFoundRecords, mySQLStatement, myRecordCount, myNum
    Dim myField, myTextNum, myDynamicText, myNewPath
    If myApp.Documents.Count > 0 Then
        Set myDBConnection = New ADODB.Connection
        myDBConnection.Open "personalize", "", ""
        
        Set myFoundRecords = New ADODB.Recordset
        
        mySQLStatement = "SELECT * FROM [data]"
        myFoundRecords.Open mySQLStatement, myDBConnection, 3, 3
        
        myRecordCount = myFoundRecords.RecordCount
        If myRecordCount > 0 Then
            'Loop through all of the records in the database.
            myNum = 1
            Do While Not myFoundRecords.EOF
                For Each myField In myFoundRecords.Fields
                    For myTextNum = 1 To myApp.Documents(1).TextArtItems.Count
                        'Loop through all of text art items in the document.
                        myDynamicText = myApp.Documents(1).TextArtItems(myTextNum).Contents
                        myDynamicText = Replace(myDynamicText, "#" & myField.Name & "#", myField.Value)
                        myApp.Documents(1).TextArtItems(myTextNum).Contents = myDynamicText
                    Next
                Next
                'Done merging dynamic text into document.
                myNewPath = exportDocument("pdf", myNum, "", True)
                'Export the personalized document as a unique pdf file.
                myNum = myNum + 1
                myFoundRecords.MoveNext
                'Move to the next record in the found records of our database.
            Loop
        End If
    End If
End Sub

'4.06

Private Function exportDocument(myFormat, myNameExtra, mySaveFolder, myRestoreFlag)
    Dim myOriginalFile, myNewPath, myCharNum, myExportOptions, myColor
    myOriginalFile = myApp.Documents(1).FullName
    If mySaveFolder <> "" Then
        myNewPath = mySaveFolder & "\"
        If Left(myOriginalFile, 1) <> "\" Then myNewPath = myNewPath & myApp.Documents(1).Name
    Else
        myNewPath = myOriginalFile
    End If
    If InStrRev(myOriginalFile, ".") > Len(myOriginalFile) - 5 Then
        myNewPath = Mid(myOriginalFile, 1, InStrRev(myOriginalFile, ".") - 1)
    End If
    myNewPath = myNewPath & myNameExtra
    Select Case myFormat
        Case "eps"
            myNewPath = myNewPath & ".eps"
            Set myExportOptions = New Illustrator.EPSSaveOptions
            myExportOptions.CMYKPostScript = True
            myExportOptions.Compatibility = aiIllustrator10
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedLinkedFiles = True
            myExportOptions.IncludeDocumentThumbnails = True
            myExportOptions.PostScript = aiLevel2
            myExportOptions.Preview = aiColorTIFF
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
        Case "flash"
            myNewPath = myNewPath & ".swf"
            Set myExportOptions = New Illustrator.ExportOptionsFlash
            myExportOptions.ArtBoardClipping = True
            myExportOptions.CurveQuality = 9
            myExportOptions.ExportStyle = aiLayersAsFrames
            myExportOptions.FrameRate = 15#
            myExportOptions.GenerateHTML = False
            myExportOptions.ImageFormat = aiLossy
            myExportOptions.JPEGMethod = aiJPEGOptimized
            myExportOptions.JPEGQuality = 7
            myExportOptions.Looping = False
            myExportOptions.ReadOnly = False
            myExportOptions.Replacing = aiSaveChanges
            myExportOptions.Resolution = 72#
            myApp.Documents(1).Export myNewPath, aiFlash, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
            
        Case "gif"
            myNewPath = myNewPath & ".gif"
            Set myExportOptions = New Illustrator.ExportOptionsGIF
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.InfoLossPercent = 0
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 0#
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiGIF, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "jpeg"
            myNewPath = myNewPath & ".jpg"
            Set myExportOptions = New Illustrator.ExportOptionsJPEG
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.BlurAmount = 0#
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.Optimization = True
            myExportOptions.QualitySetting = 70
            myExportOptions.SaveAsHTML = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiJPEG, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "pdf"
            myNewPath = myNewPath & ".pdf"
            Set myExportOptions = New Illustrator.PDFSaveOptions
            myExportOptions.ColorCompression = aiJPEGHigh
            myExportOptions.ColorDownsampling = 300#
            myExportOptions.Compatibility = aiAcrobat4
            myExportOptions.CompressArt = True
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.FontSubsetThreshold = 0#
            myExportOptions.GenerateThumbnails = True
            myExportOptions.GrayscaleCompression = aiJPEGHigh
            myExportOptions.GrayscaleDownsampling = 200#
            myExportOptions.MonochromeCompression = aiCCIT3
            myExportOptions.MonochromeDownsampling = 600#
            myExportOptions.PreserveEditability = False
            myApp.Documents(1).SaveAs myNewPath, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
        
        Case "photoshop"
            myNewPath = myNewPath & ".psd"
            Set myExportOptions = New Illustrator.ExportOptionsPhotoshop
            myExportOptions.AntiAliasing = True
            myExportOptions.CompoundShapes = True
            myExportOptions.EditableText = True
            myExportOptions.EmbedICCProfile = False
            myExportOptions.HiddenLayers = False
            myExportOptions.ImageColorSpace = aiImageCMYK
            myExportOptions.ImageMap = True
            myExportOptions.NestedLayers = True
            myExportOptions.Resolution = 144#
            myExportOptions.Slices = True
            myExportOptions.Warnings = False
            myExportOptions.WriteLayers = True
            myApp.Documents(1).Export myNewPath, aiPhotoshop, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "png24"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New Illustrator.ExportOptionsPNG24
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 255#
            myColor.Green = 255#
            myColor.Blue = 255#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myApp.Documents(1).Export myNewPath, aiPNG24, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
        
        Case "png8"
            myNewPath = myNewPath & ".png"
            Set myExportOptions = New Illustrator.ExportOptionsPNG8
            myExportOptions.AntiAliasing = True
            myExportOptions.ArtBoardClipping = True
            myExportOptions.ColorCount = 256#
            myExportOptions.ColorDither = aiDiffusion
            myExportOptions.ColorReduction = aiAdaptive
            myExportOptions.DitherPercent = 50
            myExportOptions.HorizontalScale = 100#
            myExportOptions.Interlaced = True
            myExportOptions.Matte = True
            Set myColor = New Illustrator.RGBColor
            myColor.Red = 0
            myColor.Green = 255#
            myColor.Blue = 0#
            myExportOptions.MatteColor = myColor
            myExportOptions.SaveAsHTML = False
            myExportOptions.Transparency = False
            myExportOptions.VerticalScale = 100#
            myExportOptions.WebSnap = 0
            myApp.Documents(1).Export myNewPath, aiPNG8, myExportOptions
            If myRestoreFlag = False Then
                myApp.Documents(1).Close (aiDoNotSaveChanges)
            End If
            
        Case "svg"
            myNewPath = myNewPath & ".svg"
            Set myExportOptions = New Illustrator.ExportOptionsSVG
            myExportOptions.Compressed = False
            myExportOptions.CoordinatePrecision = 5
            myExportOptions.CSSProperties = aiStyleAttributes
            myExportOptions.DocumentEncoding = aiUTF8
            myExportOptions.EmbedAllFonts = True
            myExportOptions.EmbedRasterImages = True
            myExportOptions.FontSubsetting = aiAllGlyphs
            myExportOptions.IncludeFileInfo = True
            myExportOptions.IncludeVariablesAndDatasets = False
            myExportOptions.OptimizeForSVGViewer = True
            myExportOptions.PreserveEditability = False
            myExportOptions.Slices = True
            myApp.Documents(1).Export myNewPath, aiSVG, myExportOptions
            myApp.Documents(1).Close (aiDoNotSaveChanges)
            If myRestoreFlag Then
                myApp.Open (myOriginalFile)
            End If
    End Select
    exportDocument = myNewPath
End Function


